﻿class App {

    private calcolatrice: Calcolatrice;
    private operazioni: HTMLInputElement;
    private risultato: HTMLInputElement;
    private operazione: Function;
    private risultatoVisualizzato: boolean;

    public constructor(calcolatrice: Calcolatrice, operazioni: HTMLInputElement, risultato: HTMLInputElement) {
        this.calcolatrice = calcolatrice;
        this.operazioni = operazioni;
        this.risultato = risultato;
        this.risultatoVisualizzato = false;
    }

    public ImpostaOperazione(operazione: Function) {
        this.operazione = operazione;
    }


    public Calcolatrice(): Calcolatrice {
        return this.calcolatrice;
    }

    private SvuotaRisultato(): void{
        this.ScriviRisultato("0");
        this.operazione = null;
    }
    private AggiungiAlRisultato(output: string) {
        this.ScriviRisultato(this.risultato.value + output);
    }
    private ScriviRisultato(output: string) {
        this.risultato.value = output;
    }
    private AccodaOperazione(output: string) {
        this.operazioni.value += output;
    }

    public Digita(input: any): void {

        if (this.risultatoVisualizzato) {
            this.risultatoVisualizzato = false;
            this.ScriviRisultato("0");
        }

        if (this.calcolatrice.Totale() == 0) {
            this.calcolatrice.Somma(<number>input);
            this.ScriviRisultato(input.toString());
            this.AccodaOperazione(input.toString());
            this.risultatoVisualizzato = true;
            return;
        }

        if (!isNaN(input)) {
            if (this.risultato.value == "0") {
                this.ScriviRisultato("");
            }
            this.AggiungiAlRisultato(input.toString());
        } else if (input == "±") {
            this.ScriviRisultato((parseFloat(this.risultato.value) * -1).toString());
        } else if (input == "." && this.risultato.value.indexOf('.') == -1) {
            this.AggiungiAlRisultato('.');
        }

    }

    public Calcola(): void {
        if (this.operazione == null) {
            console.error("Impossibile calcolare, operazione non impostata");
            this.SvuotaRisultato();
            return;
        }
        var input: number = parseFloat(this.risultato.value);
        if (isNaN(input)) {
            console.error("Il valore digitato non è valido");
            this.SvuotaRisultato();
            return;
        }

        var output: string = this.operazione.call(this.calcolatrice, input);
        this.AccodaOperazione(output);
        this.SvuotaRisultato();
        this.ScriviRisultato(this.calcolatrice.Totale().toString());
        this.risultatoVisualizzato = true;
    }

    public Azzera(): void {
        this.calcolatrice.Azzera();
        this.operazioni.value = "";
        this.SvuotaRisultato();
        this.ScriviRisultato("0");
    }

}
var app: App;
window.onload = function () {
   app = new App(
        new Calcolatrice(),
        <HTMLInputElement>document.getElementById("operazioni"),
        <HTMLInputElement>document.getElementById("risultato")
        );
}
